//+------------------------------------------------------------------+
//|                                        SuperTrend volty like.mq4 |
//|                                                           Mladen |
//| initial idea by jntrader                                         |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrOrange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1


extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT;
extern int                period          = 10;
extern ENUM_APPLIED_PRICE appliedPrice    = PRICE_CLOSE;
extern double             multiplier      = 4.0;
extern string             note            = "turn on Alert = true; turn off = false";
extern bool               alertsOn        = true;
extern bool               alertsOnCurrent = false;
extern bool               alertsMessage   = true;
extern bool               alertsSound     = true;
extern bool               alertsEmail     = false;
extern string             soundfile       = "alert2.wav";

//
//
//
//
//

double TrendU[];
double TrendHU[];
double TrendD[];
double TrendHD[];
double Direction[];
double Up[];
double Dn[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0, TrendHU); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,"SuperTrend up");
      SetIndexBuffer(1, TrendHD); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(2,"SuperTrend down");
      SetIndexBuffer(2, TrendU);
      SetIndexBuffer(3, TrendD);
      SetIndexBuffer(4, Direction);
      SetIndexBuffer(5, Up);
      SetIndexBuffer(6, Dn);
      
         period            = MathMax(1,period);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame == -99;
         TimeFrame         = MathMax(TimeFrame,_Period);
   
      IndicatorShortName(timeFrameToString(TimeFrame)+" SuperTrend");
   
   return(0);
}
int deinit() {  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { TrendHU[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
     
   if (TimeFrame == Period())
   {
      for(int i = limit; i >= 0; i--)
      {
         double atr    = iATR(NULL,0,period,i);
         double cprice = iMA(NULL,0,1,0,MODE_SMA,appliedPrice,i);
         double mprice = (High[i]+Low[i])/2;
             Up[i]  = mprice+multiplier*atr;
             Dn[i]  = mprice-multiplier*atr;
         
         //
         //
         //
         //
         //
         
         Direction[i] = Direction[i+1];
            if (cprice > Up[i+1]) Direction[i] =  1;
            if (cprice < Dn[i+1]) Direction[i] = -1;

            TrendU[i]  = EMPTY_VALUE;
            TrendHU[i] = EMPTY_VALUE;
            TrendD[i]  = EMPTY_VALUE;
            TrendHD[i] = EMPTY_VALUE;
         
            if (Direction[i] > 0) { Dn[i] = MathMax(Dn[i],Dn[i+1]); TrendU[i] = Dn[i]; TrendHU[i] = 1; }
            else                  { Up[i] = MathMin(Up[i],Up[i+1]); TrendD[i] = Up[i]; TrendHD[i] = 1; }
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
         
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;
         if (Direction[whichBar] != Direction[whichBar+1])
         if (Direction[whichBar] == 1)
               doAlert("up trend");
         else  doAlert("down trend");       
      }   
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
       int y = iBarShift(NULL,TimeFrame,Time[i]);               
       int x = iBarShift(NULL,TimeFrame,Time[i+1]);               
          TrendHU[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,period,appliedPrice,multiplier,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,0,y);
          TrendHD[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,period,appliedPrice,multiplier,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,1,y);
   }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SuperTrend ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," SuperTrend "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}